Uses crt, graph;                       { PR - 1 }
Const n=100; dt=0.2; h=1; Tsr=4;
Var i,k,DV,MV : integer; T,v: array[1..N] of real;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
v[1]:=0; v[N]:=0; line(50,0,50,480); line(550,0,550,480);
For i:=1 to N do begin T[i]:=0.1*i; circle(50+5*i,140,2);
circle(50+5*i,140-round(10*T[i]),2); end;
Repeat k:=k+1;
For i:=2 to N-1 do
v[i]:=v[i]+2*(v[i-1]-2*v[i]+v[i+1])/h/h*dt+0.3*(T[i]-Tsr)*dt;
For i:=N-1 downto 2 do
v[i]:=v[i]+2*(v[i-1]-2*v[i]+v[i+1])/h/h*dt+0.3*(T[i]-Tsr)*dt;
If k mod 150=0 then For i:=1 to N do begin
circle(50+5*i,320-round(v[i]),2);
circle(50+5*i,320-round(v[i]),1); end;
until (KeyPressed); CloseGraph;
END.


{Konvekciya -rabotaet medlenno}              {PR-2}
Uses crt, graph;             { Free Pascal }
Const N=130; M=40; dt=0.0005; h=1; nu=2;
Var i,j,k,DV,MV,EC:integer;
psi,w,T:array[0..N+1,0..M+1] of real;
Procedure Gr_usl;
begin For i:=0 to N+1 do For j:=0 to M+1 do begin
T[i,0]:=0; T[i,M+1]:=10;
T[0,j]:=T[1,j]; T[N+1,j]:=T[N,j];
psi[0,j]:=0; psi[N+1,j]:=0;
psi[i,0]:=0; psi[i,M+1]:=0;
w[i,M]:=2*psi[i,M]/h/h; w[1,j]:=2*psi[1,j]/h/h;
w[N,j]:=2*psi[N,j]/h/h; w[i,1]:=2*psi[i,1]/h/h;
w[0,j]:=0; w[N+1,j]:=0; w[i,M+1]:=0; w[i,0]:=0; end; end;
Procedure Ur1;
begin psi[i,j]:=(psi[i-1,j]+psi[i+1,j]+
psi[i,j-1]+psi[i,j+1]-w[i,j]*h*h)/4; end;
Procedure Ur2;
begin w[i,j]:=w[i,j]-(psi[i,j+1]-psi[i,j-1])*(w[i+1,j]-
w[i-1,j])*dt/4/h+(psi[i+1,j]-psi[i-1,j])*(w[i,j+1]-
w[i,j-1])*dt/4/h+nu*(w[i-1,j]-4*w[i,j]+w[i+1,j]+
w[i,j-1]+w[i,j+1])/h/h*dt+0.001*(T[i+1,j]-T[i-1,j]); end;
Procedure Ur3;
begin T[i,j]:=T[i,j]+3*(T[i-1,j]-4*T[i,j]+T[i+1,j]+
T[i,j-1]+T[i,j+1])/h/h*dt-
(psi[i,j+1]-psi[i,j-1])*(T[i+1,j]-T[i-1,j])*dt/4/h+
(psi[i+1,j]-psi[i-1,j])*(T[i,j+1]-T[i,j-1])*dt/4/h; end;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Repeat  Gr_usl; For i:=1 to N do For j:=1 to M do Ur1;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur1;
  Gr_usl; For i:=1 to N do For j:=1 to M do Ur2;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur2;
  Gr_usl; For i:=1 to N do For j:=1 to M do Ur3;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur3;
  inc(k); If k mod 500=0 then begin cleardevice; k:=0;
  For i:=1 to N do For j:=1 to M do begin
  setcolor(abs(round(psi[i,j]/10))mod 12+2);
  circle(i*6,j*6,1); circle(i*6,j*6,2); circle(i*6,j*6,3);
  setcolor(abs(round(T[i,j]))mod 12+2);
  circle(i*6,j*6+250,2); circle(i*6,j*6+250,3); end; end;
until KeyPressed; CloseGraph;
END.



Uses crt, graph;
Const N=80; M=40; dt=0.0005; h=1; nu=2;
Var i,j,k,DV,MV,EC:integer;
psi,w,T:array[0..N+1,0..M+1] of real;
Procedure Gr_usl;
begin For i:=0 to N+1 do For j:=0 to M+1 do begin
T[i,0]:=0; T[i,M+1]:=0; T[60,23]:=10;
T[0,j]:=T[1,j]; T[N+1,j]:=T[N,j];
psi[0,j]:=0; psi[N+1,j]:=0;
psi[i,0]:=0; psi[i,M+1]:=0;
w[i,M]:=2*psi[i,M]/h/h; w[1,j]:=2*psi[1,j]/h/h;
w[N,j]:=2*psi[N,j]/h/h; w[i,1]:=2*psi[i,1]/h/h;
w[0,j]:=0; w[N+1,j]:=0; w[i,M+1]:=0; w[i,0]:=0; end; end;
Procedure Ur1;
begin psi[i,j]:=(psi[i-1,j]+psi[i+1,j]+
psi[i,j-1]+psi[i,j+1]-w[i,j]*h*h)/4; end;
Procedure Ur2;
begin w[i,j]:=w[i,j]-(psi[i,j+1]-psi[i,j-1])*(w[i+1,j]-
w[i-1,j])*dt/4/h+(psi[i+1,j]-psi[i-1,j])*(w[i,j+1]-
w[i,j-1])*dt/4/h+nu*(w[i-1,j]-4*w[i,j]+w[i+1,j]+
w[i,j-1]+w[i,j+1])/h/h*dt+0.001*(T[i+1,j]-T[i-1,j]); end;
Procedure Ur3;
begin T[i,j]:=T[i,j]+3*(T[i-1,j]-4*T[i,j]+T[i+1,j]+
T[i,j-1]+T[i,j+1])/h/h*dt-
(psi[i,j+1]-psi[i,j-1])*(T[i+1,j]-T[i-1,j])*dt/4/h+
(psi[i+1,j]-psi[i-1,j])*(T[i,j+1]-T[i,j-1])*dt/4/h; end;
BEGIN DV:=Detect; InitGraph(DV,MV,'c:\bp\bgi');
Repeat  Gr_usl; For i:=1 to N do For j:=1 to M do Ur1;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur1;
  Gr_usl; For i:=1 to N do For j:=1 to M do Ur2;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur2;
  Gr_usl; For i:=1 to N do For j:=1 to M do Ur3;
  Gr_usl; For i:=N downto 1 do For j:=M downto 1 do Ur3;
  inc(k); If k mod 500=0 then begin cleardevice; k:=0;
  For i:=1 to N do For j:=1 to M do begin
  setcolor(abs(round(psi[i,j]/10))mod 12+2);
  circle(i*6,j*6,1); circle(i*6,j*6,2); circle(i*6,j*6,3);
  setcolor(abs(round(T[i,j]))mod 12+2);
  circle(i*6,j*6+250,2); circle(i*6,j*6+250,3); end; end;
until KeyPressed; CloseGraph;
END.
